#ifndef __MACHINE_H__
#define __MACHINE_H__

/* Sets mem to a non-zero value and returns the previous value */
__inline__ char test_and_set (volatile char *mem)
{
	char ret;

	__asm__ __volatile__("
	ldstub	%1,%0"
	: "=r"(ret), "=m"(*mem) 
	: "m"(*mem));

	return ret;
}              

/* Adds val to mem and returns the previous value of mem */
__inline__ int fetch_and_add (volatile long *mem, long val)
{
	unsigned int tmp1, tmp2;

	__asm__ __volatile__("
1:	lduw	[%2], %0
	add	%0, %3, %1
	cas	[%2], %0, %1
	sub	%0, %1, %0  
	brnz,pn %0, 1b
	nop"
	: "=&r" (tmp1), "=&r" (tmp2)
	: "r" (mem), "r" (val)
	: "memory");
	
	return tmp2;
}
                                                                                                         
#endif
