/*

  ticket_lock.c: Ticket Lock.
  Copyright (C) 2001 Thomas Repantis <darkzero@otenet.gr>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/
 
/*

  These functions implement the Ticket Lock.

*/

#include <stdio.h>
#include "machine.h"
#include "libsync.h"


void ticket_init(struct ticket_lock *thr_ticket_lock_ptr)
{
  /* ticket_init initializes the ticket_lock. */

  thr_ticket_lock_ptr->next_ticket = 0;
  thr_ticket_lock_ptr->now_serving = 0;
}

void ticket_lock(struct ticket_lock *thr_ticket_lock_ptr)
{
  /* ticket_lock acquires the ticket_lock pointed to it by a thread. */

  int ticket = 0;

  ticket = fetch_and_add(&thr_ticket_lock_ptr->next_ticket, 1);

  while( ticket != thr_ticket_lock_ptr->now_serving)
    ;
}

void ticket_unlock(struct ticket_lock *thr_ticket_lock_ptr)
{
  /* ticket_unlock releases the ticket_lock pointed to it by a thread. */

  (thr_ticket_lock_ptr->now_serving)++;
}
